Faiss

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
Public Member Functions | Public Attributes | List of all members
faiss::IndexIVFScalarQuantizer Struct Reference

`#include <IndexScalarQuantizer.h>`

Inheritance diagram for faiss::IndexIVFScalarQuantizer:

## Public Member Functions
| IndexIVFScalarQuantizer (Index *quantizer, size_t d, size_t nlist, ScalarQuantizer::QuantizerType qtype, MetricType metric=METRIC_L2)
void | train_residual (idx_t n, const float *x) override
void | encode_vectors (idx_t n, const float *x, const idx_t *list_nos, uint8_t *codes) const override
void | add_with_ids (idx_t n, const float *x, const long *xids) override
| default implementation that calls encode_vectors
InvertedListScanner * | get_InvertedListScanner (bool store_pairs) const override
| get a scanner for this index (store_pairs means ignore labels)
void | reconstruct_from_offset (long list_no, long offset, float *recons) const override
Public Member Functions inherited from faiss::IndexIVF
| IndexIVF (Index *quantizer, size_t d, size_t nlist, size_t code_size, MetricType metric=METRIC_L2)
void | reset () override
| removes all elements from the database.
void | train (idx_t n, const float *x) override
| Trains the quantizer and calls train_residual to train sub-quantizers.
void | add (idx_t n, const float *x) override
| Calls add_with_ids with NULL ids.
virtual void | search_preassigned (idx_t n, const float *x, idx_t k, const idx_t *assign, const float *centroid_dis, float *distances, idx_t *labels, bool store_pairs, const IVFSearchParameters *params=nullptr) const
void | search (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels) const override
void | range_search (idx_t n, const float *x, float radius, RangeSearchResult *result) const override
void | range_search_preassigned (idx_t nx, const float *x, float radius, const idx_t *keys, const float *coarse_dis, RangeSearchResult *result) const
void | reconstruct (idx_t key, float *recons) const override
void | reconstruct_n (idx_t i0, idx_t ni, float *recons) const override
void | search_and_reconstruct (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels, float *recons) const override
idx_t | remove_ids (const IDSelector &sel) override
| Dataset manipulation functions.
void | check_compatible_for_merge (const IndexIVF &other) const
virtual void | merge_from (IndexIVF &other, idx_t add_id)
virtual void | copy_subset_to (IndexIVF &other, int subset_type, idx_t a1, idx_t a2) const
size_t | get_list_size (size_t list_no) const
void | make_direct_map (bool new_maintain_direct_map=true)
void | replace_invlists (InvertedLists *il, bool own=false)
| replace the inverted lists, old one is deallocated if own_invlists
Public Member Functions inherited from faiss::Index
| Index (idx_t d=0, MetricType metric=METRIC_L2)
void | assign (idx_t n, const float *x, idx_t *labels, idx_t k=1)
void | compute_residual (const float *x, float *residual, idx_t key) const
void | display () const
Public Member Functions inherited from faiss::Level1Quantizer
void | train_q1 (size_t n, const float *x, bool verbose, MetricType metric_type)
| Trains the quantizer and calls train_residual to train sub-quantizers.
| Level1Quantizer (Index *quantizer, size_t nlist)

## Public Attributes
ScalarQuantizer | sq
bool | by_residual
Public Attributes inherited from faiss::IndexIVF
InvertedLists * | invlists
| Acess to the actual data.
bool | own_invlists
size_t | code_size
| code size per vector in bytes
size_t | nprobe
| number of probes at query time
size_t | max_codes
| max nb of codes to visit to do a query
int | parallel_mode
bool | maintain_direct_map
| map for direct access to the elements. Enables reconstruct().
std::vector< idx_t > | direct_map
Public Attributes inherited from faiss::Index
int | d
| vector dimension
idx_t | ntotal
| total nb of indexed vectors
bool | verbose
| verbosity level
bool | is_trained
| set if the Index does not require training, or if training is done already
MetricType | metric_type
| type of metric this index uses for search
Public Attributes inherited from faiss::Level1Quantizer
Index * | quantizer
| quantizer that maps vectors to inverted lists
size_t | nlist
| number of possible key values
char | quantizer_trains_alone
bool | own_fields
| whether object owns the quantizer
ClusteringParameters | cp
| to override default clustering params
Index * | clustering_index
| to override index used during clustering

## Additional Inherited Members
Public Types inherited from faiss::Index
using | idx_t = long
| all indices are this type
using | component_t = float
using | distance_t = float

## Detailed Description

An IVF implementation where the components of the residuals are encoded with a scalar uniform quantizer. All distance computations are asymmetric, so the encoded vectors are decoded and approximate distances are computed.

Definition at line 141 of file IndexScalarQuantizer.h.

## Member Function Documentation

void faiss::IndexIVFScalarQuantizer::encode_vectors | ( | idx_t | n,
|  | const float * | x,
|  | const idx_t * | list_nos,
|  | uint8_t * | codes
| ) |  | const
| override virtual

Encodes a set of vectors as they would appear in the inverted lists

Parameters

  list_nos | inverted list ids as returned by the quantizer (size n). -1s are ignored.
  codes | output codes, size n * code_size

Implements faiss::IndexIVF.

Definition at line 1764 of file IndexScalarQuantizer.cpp.

void faiss::IndexIVFScalarQuantizer::reconstruct_from_offset | ( | long | list_no,
|  | long | offset,
|  | float * | recons
| ) |  | const
| override virtual

Reconstruct a vector given the location in terms of (inv list index + inv list offset) instead of the id.

Useful for reconstructing when the direct_map is not maintained and the inv list offset is computed by search_preassigned() with `store_pairs` set.

Reimplemented from faiss::IndexIVF.

Definition at line 1850 of file IndexScalarQuantizer.cpp.

void faiss::IndexIVFScalarQuantizer::train_residual | ( | idx_t | n,
|  | const float * | x
| ) |  |
| override virtual

Sub-classes that encode the residuals can train their encoders here does nothing by default

Reimplemented from faiss::IndexIVF.

Definition at line 1735 of file IndexScalarQuantizer.cpp.

The documentation for this struct was generated from the following files:

- /data/users/hoss/faiss/IndexScalarQuantizer.h
- /data/users/hoss/faiss/IndexScalarQuantizer.cpp